/**
 * @author Nicolas Barradeau 
 */

	SSAO = true;
	var state = 0;
	var m = new THREE.Matrix4();
	var t = new THREE.Vector3();
	var q = new THREE.Quaternion();
	var s = new THREE.Vector3();
	
	var obj = function( mat, i, j )
	{
		
		if( state == 0 )
		{
			this.mesh = new THREE.Mesh( geom_sphere_3, MAT_CLEAR );
		}
		else
		{
			this.mesh = new THREE.Mesh( geom_sphere_3, ( i % 2 == j % 2 ) ? MAT_CLEAR : MAT_DARK );
			this.mesh.scale.multiplyScalar( 10 );
		}
		if( state >= 2 ) this.time = i + j;
		if( state == 3 ) this.time *= Math.random();
		
		group.add( this.mesh );
		
		mat.decompose( t, q, s );
		this.mesh.position.copy( t );
		
		this.update = function()
		{
			
			if( state < 2 )return;
			
			this.time += .1;
			this.mesh.scale.x = 10 + ( .5 + Math.cos( this.time ) * .5 ) * 20;
			this.mesh.scale.y = 10 + ( .5 + Math.sin( this.time ) * .5 ) * 20;
			this.mesh.scale.z = 10 + ( .5 + Math.sin( this.time ) * Math.cos( this.time ) * .5 ) * 20;
			
		}
		
		return this;
	}
	
	function addMesh()
	{
		for( var i = 0; i < 10; i++ )
		{
			for( var j = 0; j < 10; j++ )
			{
				m.identity();
				m.makeTranslation( -125 + i * 25, -125 + j * 25, 0 );
				items.push( new obj( m, i, j ) );
			}
		}
	}
	
	function update()
	{
		items.forEach( function( e, i, a ){	e.update();	});
	}
	
	setInterval( update, 1000 / 30 );
	
	
	function onDown( e )
	{
		
		while( items[ 0 ] != null ) 
		{
			group.remove( items[0].mesh );
			items.shift();
		}
		state++;
		state %= 4;
		addMesh();
	
	}
	window.addEventListener( 'mousedown', onDown );
	
	
	addMesh();
	