/**
 * @author Nicolas Barradeau 
 */
 
	SSAO = true;
var offset = 100;
var clear = new THREE.MeshBasicMaterial({color:0xEEEEEE} );
var dark = new THREE.MeshBasicMaterial({color:0x808080});

var axiom = "a";
var rules = [];
rules[ "a" ] = "ab";
rules[ "b" ] = "a";

var meshes = [];
meshes[ "a" ] = new THREE.IcosahedronGeometry( 10, 2 );
meshes[ "b" ] = new THREE.CubeGeometry( 20, 20, 20 );
var iteration = 0;
function rewrite()
{
	
	var new_axiom = "";
	var tmp = axiom.split( '' );
	var total = tmp.length;
	for( var i = 0; i < total; i++ )
	{
		new_axiom += rules[ tmp[ i ] ];
		
		var mesh = new THREE.Mesh( meshes[ tmp[ i ] ], rules[ tmp[ i ] ] == "a" ? dark : clear );
		group.add( mesh );
		
		mesh.position.x = i * 20 -( ( 20 * total ) / 2 );
		mesh.position.y = offset;
		
	}
	offset -= 20;
	axiom = new_axiom;
	if( iteration++ > 8 )
	{
		axiom = "a";
		offset = 100;
	}
	return axiom;
	
}
rewrite();
function onDown( e ){ rewrite(); }
window.addEventListener( 'mousedown', onDown );